// XMS for the small model !
// Idea from book: "M. Tischer, PC intern 3.0, DATA BECKER GmbH Germany"

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <alloc.h>
#include <mem.h>

#include "xms.h"

//---------------------------------------------------------------------------
// constructor
//---------------------------------------------------------------------------
XMSHandler::XMSHandler ()
{ VerNr = 0;
  RevNr = 0;
  TotalFree = 0;
  MaxBl = 0;
  StartAdress = 0;
}

//---------------------------------------------------------------------------
// destructor
//---------------------------------------------------------------------------
XMSHandler::~XMSHandler ()
{
}

//---------------------------------------------------------------------------
// functions
//---------------------------------------------------------------------------
void XMSHandler::Call (BYTE Number, XMSRegs *Xr)
{ asm {
    mov  cx,ds				// DS to CX
    push cx				// and to the stack
    mov  di,[bp+08]                     // Pointer to structure
    mov  ah,[bp+06]			// Functionnumber to AH
    mov  bx,[di+02] 			// Load registers with the content of
    mov  dx,[di+04]			// the components of the structure
    mov	 si,[di+06]
    mov  ds,[di+08]
    mov  es,cx                          // CX to ES
    call es:[XMSPtr]			// call XMS-handler
    mov	 cx,ds				// DS to CX
    pop  ds				// old DS back
    mov  di,[bp+08]			// Pointer to structure
    mov  [di],ax			// Load components of the structure
    mov  [di+02],bx			// with content of the registers
    mov  [di+04],dx
    mov  [di+06],si
    mov  [di+08],cx
  }
}

BOOL XMSHandler::Init ()
{ union REGS Regs;
  struct SREGS SRegs;
  XMSRegs Xr;

  Regs.x.ax = 0x4300;				// AX = 0x4300			
  int86 (0x2F, &Regs, &Regs);			// interrupt 0x2F
  if (Regs.h.al == 0x80)
    { Regs.x.ax = 0x4310;
      int86x (0x2F, &Regs, &Regs, &SRegs);
      XMSPtr = MK_FP (SRegs.es, Regs.x.bx);
      Err = ERR_NOERR;
      return TRUE;
    }
  else
    return FALSE;
}

BOOL XMSHandler::Version ()
{ XMSRegs Xr;

  Call (0x00, &Xr);
  VerNr = (HIBYTE (Xr.AX) * 100) + ((LOBYTE (Xr.AX) >> 4) * 10) +
	  (LOBYTE (Xr.AX) & 0xF);
  RevNr = (HIBYTE (Xr.BX) * 100) + ((LOBYTE (Xr.BX) >> 4) * 10) +
	  (LOBYTE (Xr.BX) & 0xF);
  return (Xr.DX == 1);
}

void XMSHandler::getSize ()
{ XMSRegs Xr;

  Call (0x08, &Xr);
  TotalFree = Xr.AX;
  MaxBl   = Xr.DX;
}

int XMSHandler::getMem (int lengthKB)
{ XMSRegs Xr;

  Xr.DX = lengthKB;
  Call (0x09, &Xr);
  return Xr.DX;
}

void XMSHandler::freeMem (int Handle)
{ XMSRegs Xr;

  Xr.DX = Handle;
  Call (0x0A, &Xr);
}

void XMSHandler::Copy (int SourceHandle, long SourceOffset,
		       int DestHandle, long DestOffset, int LengthW)
{ XMSRegs Xr;
  EMMS    Mi;
  void far *MiPtr;

  Mi.LengthB = 2 * LengthW;
  Mi.SHandle = SourceHandle;
  Mi.SOffset = SourceOffset;
  Mi.DHandle = DestHandle;
  Mi.DOffset = DestOffset;
  MiPtr = &Mi;
  Xr.Segment = FP_SEG (MiPtr);
  Xr.SI      = FP_OFF (MiPtr);
  Call (0x0B, &Xr);
}

long XMSHandler::Lock (int Handle)
{ XMSRegs Xr;

  Xr.DX = Handle;
  Call (0x0C, &Xr);
  return ((long) Xr.DX << 16) + Xr.BX;
}

void XMSHandler::Unlock (int Handle)
{ XMSRegs Xr;

  Xr.DX = Handle;
  Call (0x0D, &Xr);
}

void XMSHandler::Info (int Handle, int *LockCounter, int *LengthBlockKB,
		       int *FreeHandles)
{ XMSRegs Xr;

  Xr.DX = Handle;
  Call (0x0E, &Xr);
  *LengthBlockKB = Xr.DX;
  *FreeHandles  = LOBYTE (Xr.BX);
  *LockCounter   = HIBYTE (Xr.BX);
}

BOOL XMSHandler::Realloc (int Handle, int NewLengthKB)
{ XMSRegs Xr;

  Xr.DX = Handle;
  Xr.BX = NewLengthKB;
  Call (0x0F, &Xr);
  return (Err == ERR_NOERR);
}


main ()
{ XMSHandler XMSH;
  long Addr;
  BYTE *buffer1KB;
  int i, j, err, Handle;

  if (XMSH.Init ())
    { XMSH.Version ();
      XMSH.getSize ();
      printf ("\nXMS-Version Number: %d.%d", XMSH.VerNr / 100, XMSH.VerNr % 100);
      printf ("\nControl Number    : %d.%d", XMSH.RevNr / 100, XMSH.RevNr % 100);
      printf ("\nExtended-Memory-Block (EMB) Test : hit a key to start !\n");
      getch ();
      printf ("\nTotal size of Extended Memory (incl. HMA) : %d KB", XMSH.TotalFree);
      printf ("\n                   ... largest free block : %d KB\n", XMSH.MaxBl);
      XMSH.TotalFree -= 64;                            // without HMA (64 KB)
      if (XMSH.MaxBl >= XMSH.TotalFree)
	XMSH.MaxBl -= 64;

      if (XMSH.MaxBl > 0)
	{ Handle = XMSH.getMem (XMSH.MaxBl);
	  printf ("\n%d KB allocated.\n", XMSH.MaxBl);
	  printf ("\nHandle        = %d\n", Handle);
	  Addr = XMSH.Lock (Handle);
	  printf ("\nStartaddress   = %ld (%d KB)\n", Addr, Addr >> 10);
	  buffer1KB = (char *) malloc (1024);
	  err = 0;
	  for (i = 0; i < XMSH.MaxBl; i++)
	    { printf ("\rKB-Test: %d", i+1);

	      memset (buffer1KB, i % 255, 1024);
	      XMSH.Copy (0, (long) ((void far *)buffer1KB), Handle, (long) i*1024, 512);

	      memset (buffer1KB, 255, 4096);
	      XMSH.Copy (Handle, (long) i*1024, 0, (long) ((void far *)buffer1KB), 512);

	      for (j = 0; j < 1024; j++)
		if ( *(buffer1KB+j) != i % 255)
		  { printf ("error !\n");
		    ++err;
		    break;
		  }
	    }
	  printf ("\n");
	  if (err == 0)
	    printf ("\nEMB ok, no defective 1-KB-blocks were detected !\n");
	  else
	    printf ("\nAttention !  %d defective 1-KB-blocks inside EMB detected !\n", err);
	  XMSH.Unlock (Handle);
	  free (buffer1KB);
	  XMSH.freeMem (Handle);
	}
    }
  else
    printf ("\nNo XMS-driver installed !");

  printf ("\n");
  return 0;
}
