// unit: XMS.H

#if !defined (__XMS_H)
#define __XMS_H

#define ERR_NOERR		0x00	// no error
#define ERR_NOTIMPLEMENTED	0x80 	// unknown function
#define ERR_GENERAL		0x8E	// general error
#define ERR_UNRECOVERABLE	0x8F	// unrecoverable error
#define ERR_OUTOFMEMORY		0xA0	// no more extended memory
#define ERR_OUTOFHANDLES	0xA1	// all XMS-handles used
#define ERR_INVALIDHANDLE	0xA2	// invalid handle
#define ERR_SHANDLEINVALID	0xA3	// invalid source-handle
#define ERR_SOFFSETINVALID	0xA4	// invalid source-offset
#define ERR_DHANDLEINVALID	0xA5	// invalid destination-handle
#define ERR_DOFFSETINVALID	0xA6	// invalid destination-offest
#define ERR_LENGHTINVALID	0xA7	// invalid length for move-function
#define ERR_OVERLAP		0xA8	// overlap error
#define ERR_PARITY		0xA9	// parity error
#define ERR_EMBUNLOCKED		0xAA	// EMB not locked
#define ERR_EMBLOCKED		0xAB	// EMB locked
#define ERR_LOCKOVERFLOW	0xAC	// lockoverflow error
#define ERR_LOCKFAIL		0xAD	// lockfail error

#define TRUE  (0 == 0)
#define FALSE (0 == 1)

#define HIBYTE(x) (((x) >> 8 & 0xFF))	// Hi-Byte
#define LOBYTE(x) (((x) & 0xFF))	// Lo-Byte

typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef BYTE BOOL;

void far *XMSPtr;

struct XMSRegs
{ WORD AX,				// only use of AX, BX, DX, SI
       BX,				// and segmentaddress
       DX,
       SI,
       Segment;
};

struct EMMS				// Extended-Memory-Move-Structure
{ long LengthB;				// number of bytes to be moved
  int  SHandle;				// source-handle
  long SOffset;                         // source-offset
  int  DHandle;                         // destination-handle
  long DOffset;                         // destination-offset
};

class XMSHandler
{ public:

    XMSHandler ();
    ~XMSHandler ();
    BYTE Err;
    unsigned VerNr, RevNr;
    unsigned TotalFree, MaxBl;
    long StartAdress;
    void Call (BYTE Number, XMSRegs *Xr);
    BOOL Init ();
    BOOL Version ();
    void getSize ();
    int  getMem (int lengthKB);
    void freeMem (int Handle);
    void Copy (int SourceHandle, long SourceOffset,
	       int DestHandle, long DestOffset, int LengthW);
    long Lock (int Handle);
    void Unlock (int Handle);
    void Info (int Handle, int *LockCounter, int *LengthBlockKB,
	       int *FreeHandles);
    BOOL Realloc (int Handle, int NewLengthKB);
};

#endif
